Tp::Client::ChannelRequestInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ChannelRequestInterface Class Reference
ChannelRequest proxies

`#include <TelepathyQt/ChannelRequest>`

Inherits Tp::AbstractInterface.

## Public Slots
QDBusPendingReply | Proceed (int timeout=-1)
QDBusPendingReply | Cancel (int timeout=-1)

## Signals
void | Failed (const QString &error, const QString &message)
void | Succeeded ()
void | SucceededWithChannel (const QDBusObjectPath &connection, const QVariantMap &connectionProperties, const QDBusObjectPath &channel, const QVariantMap &channelProperties)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions
| ChannelRequestInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelRequestInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelRequestInterface (Tp::DBusProxy *proxy)
Tp::PendingVariant * | requestPropertyAccount () const
Tp::PendingVariant * | requestPropertyUserActionTime () const
Tp::PendingVariant * | requestPropertyPreferredHandler () const
Tp::PendingVariant * | requestPropertyRequests () const
Tp::PendingVariant * | requestPropertyInterfaces () const
Tp::PendingVariant * | requestPropertyHints () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const

## Static Public Member Functions
static QLatin1String | staticInterfaceName ()

## Protected Member Functions
virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const

## Additional Inherited Members
Protected Slots inherited from Tp::AbstractInterface

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.ChannelRequest".

## Constructor & Destructor Documentation

Tp::Client::ChannelRequestInterface::ChannelRequestInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelRequestInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelRequestInterface::ChannelRequestInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelRequestInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelRequestInterface::ChannelRequestInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelRequestInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## Member Function Documentation

static QLatin1String Tp::Client::ChannelRequestInterface::staticInterfaceName | ( |  | ) |
| inlinestatic

Returns the name of the interface "org.freedesktop.Telepathy.ChannelRequest", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::ChannelRequestInterface::requestPropertyAccount | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Account` of type `QDBusObjectPath`.

The Account on which this request was made. This property cannot change.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelRequestInterface::requestPropertyUserActionTime | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `UserActionTime` of type `qlonglong`.

The time at which user action occurred, or 0 if this channel request is for some reason not involving user action.

This property is set when the channel request is created, and can never change.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelRequestInterface::requestPropertyPreferredHandler | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `PreferredHandler` of type `QString`.

Either the well-known bus name (starting with `org.freedesktop.Telepathy.Client.`) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

This property is set when the channel request is created, and can never change.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelRequestInterface::requestPropertyRequests | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Requests` of type `Tp::QualifiedPropertyValueMapList`.

An array of dictionaries containing desirable properties for the channel or channels to be created.

This is an array so that we could add a CreateChannels method in future without redefining the API of ChannelRequest.

This property is set when the channel request is created, and can never change.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelRequestInterface::requestPropertyInterfaces | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Interfaces` of type `QStringList`.

A list of the extra interfaces provided by this channel request. This property cannot change.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelRequestInterface::requestPropertyHints | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Hints` of type `QVariantMap`.

A dictionary of metadata provided by the channel requester, which the handler and other clients MAY choose to interpret. Clients MAY choose to use platform-specific keys for their own purposes, but MUST ignore unknown keys and MUST cope with expected keys being missing. Clients SHOULD namespace hint names by having them start with a reversed domain name, in the same way as D-Bus interface names.

This property might be used to pass a contact ID for a telephone number shared between two contacts from the address book to the call UI, so that if you try to call “Mum”, the call UI knows this rather than having to guess or show “Calling Mum or Dad”. The format of these contact IDs would be platform-specific, so we leave the definition of the dictionary entry up to the platform in question. But third-party channel requesters might not include the contact ID, so the call UI has to be able to deal with it not being there.

The channel dispatcher does not currently interpret any of these hints: they are solely for communication between cooperating clients. If hints that do affect the channel dispatcher are added in future, their names will start with an appropriate reversed domain name (e.g. `org.freedesktop.Telepathy` for hints defined by this specification, or an appropriate vendor name for third-party plugins).

This property may be set when the channel request is created, and can never change. Since it is immutable, it SHOULD be included in the dictionary of properties passed to ClientInterfaceRequestsInterface::AddRequest() by the ChannelDispatcherInterface .

The following standardised hints are defined:

org.freedesktop.Telepathy.ChannelRequest.DelegateToPreferredHandler - b
  If present and True the client currently handling the channel SHOULD pass the channel to the PreferredHandler using ChannelDispatcherInterface::DelegateChannels() .
  This hint allows the user to request a channel in their preferred client in a situation where there are two chat handlers (for example: requesting a channel in Empathy which is currently being handled by gnome-shell).
  If the channel is currently unhandled, clients SHOULD ignore this hint.
  It is assumed that Mission Control will correctly delegate an unhandled channel to the preferred Handler. This allows requesting clients to always include this hint in their channel request.
  The Handler should check each ChannelRequestInterface of the Requests_Satisfied parameter of ClientHandlerInterface::HandleChannels() for the hint. The first request containing the hint SHOULD be used and all further hints SHOULD be ignored.
  This covers the very unlikely case where ClientHandlerInterface::HandleChannels() satisfies two separate requests which have different PreferredHandler s.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::ChannelRequestInterface::requestAllProperties | ( |  | ) | const
| inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::ChannelRequestInterface::Proceed | ( | int | timeout = `-1` | ) |
| inlineslot

Begins a call to the D-Bus method `Proceed` on the remote object.

Proceed with the channel request.

The client that created this object calls this method when it has connected signal handlers for Succeeded() and Failed() .

Clients other than the client which created the ChannelRequest MUST NOT call this method.

This method SHOULD return immediately; on success, the request might still fail, but this will be indicated asynchronously by the Failed() signal.

Proceed cannot fail, unless clients have got the life-cycle of a ChannelRequest seriously wrong (e.g. a client calls this method twice, or a client that did not create the ChannelRequest calls this method). If it fails, clients SHOULD assume that the whole ChannelRequest has become useless.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::ChannelRequestInterface::Cancel | ( | int | timeout = `-1` | ) |
| inlineslot

Begins a call to the D-Bus method `Cancel` on the remote object.

Cancel the channel request. The precise effect depends on the current progress of the request.

If the connection manager has not already been asked to create a channel, then Failed() is emitted immediately, and the channel request is removed.

If the connection manager has already been asked to create a channel but has not produced one yet (e.g. if ConnectionInterfaceRequestsInterface::CreateChannel() has been called, but has not yet returned), then the ChannelDispatcher will remember that the request has been cancelled. When the channel appears, it will be closed (if it was newly created and can be closed), and will not be dispatched to a handler.

If the connection manager has already returned a channel, but the channel has not yet been dispatched to a handler then the channel dispatcher will not dispatch that channel to a handler. If the channel was newly created for this request, the channel dispatcher will close it with ChannelInterface::Close() ; otherwise, the channel dispatcher will ignore it. In either case, Failed() will be emitted when processing has been completed.

If Failed() is emitted in response to this method, the error SHOULD be `org.freedesktop.Telepathy.Error.Cancelled`.

If the channel has already been dispatched to a handler, then it's too late to call this method, and the channel request will no longer exist.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

void Tp::Client::ChannelRequestInterface::Failed | ( | const QString & | error,
|  | const QString & | message
| ) |  |
| signal

Represents the signal `Failed` on the remote object.

The channel request has failed. It is no longer present, and further methods must not be called on it.

Parameters

  error | The name of a D-Bus error. This can come from various sources, including the error raised by ConnectionInterfaceRequestsInterface::CreateChannel() , or an error generated to represent failure to establish the ConnectionInterface .
  message |
      If the first argument of the D-Bus error message was a string, that
      string. Otherwise, an empty string.

void Tp::Client::ChannelRequestInterface::Succeeded | ( |  | ) |
| signal

Represents the signal `Succeeded` on the remote object.

The channel request has succeeded. It is no longer present, and further methods must not be called on it.

void Tp::Client::ChannelRequestInterface::SucceededWithChannel | ( | const QDBusObjectPath & | connection,
|  | const QVariantMap & | connectionProperties,
|  | const QDBusObjectPath & | channel,
|  | const QVariantMap & | channelProperties
| ) |  |
| signal

Represents the signal `SucceededWithChannel` on the remote object.

Variant of the ChannelRequestInterface::Succeeded() signal allowing to get the channel which has been created.

This signal MUST be emitted if the ChannelDispatcherInterface 's ChannelDispatcherInterface::SupportsRequestHints property is true. If supported, it MUST be emitted before the Succeeded() signal.

Parameters

  connection | The Connection owning the channel.
  connectionProperties | A subset of the Connection's properties, currently unused. This parameter may be used in future.
  channel | The channel which has been created.
  channelProperties | The same immutable properties of the Channel that would appear in a ConnectionInterfaceRequestsInterface::NewChannels() signal.

void Tp::Client::ChannelRequestInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |
| protectedvirtual

Reimplemented from Tp::AbstractInterface.